package org.kikaineko.mock.analysis.innersi;

import java.lang.reflect.Array;
import java.util.Stack;

import org.kikaineko.mock.analysis.SmallInterpreterSupportor;
import org.kikaineko.mock.analysis.TypeOwner;
import org.kikaineko.mock.analysis.VariableTable;
import org.kikaineko.mock.util.Operator;
import org.kikaineko.source.util.Token;
import org.kikaineko.source.util.TokenArray;
import org.kikaineko.source.util.TokenKind;

public class CallingVariable {
	public static void run(SharedFields sf, String s) throws Exception {
		TokenArray tokenArray = sf.tokenArray;
		Stack valueStack = sf.valueStack;
		TypeOwner typeStack = sf.typeStack;
		VariableTable vt = sf.vt;

		Token t = tokenArray.getToken(sf.index++);
		if (t.getKind() == TokenKind.Eq) {
			Eq.run(sf, sf.vt.getType(s), s);
		} else if (t.getKind() == TokenKind.SaikiWa) {
			Expression.run(sf);
			Object o = valueStack.pop();
			vt.setVal(s, Operator.operate(o,vt.getVal(s),"+"));
		} else if (t.getKind() == TokenKind.SaikiSeki) {
			Expression.run(sf);
			Object o = valueStack.pop();
			vt.setVal(s, Operator.operate(vt.getVal(s), o, "*"));
		} else if (t.getKind() == TokenKind.SaikiSa) {
			Expression.run(sf);
			Object o = valueStack.pop();
			vt.setVal(s, Operator.operate(o, vt.getVal(s), "-"));
		} else if (t.getKind() == TokenKind.SaikiShou) {
			Expression.run(sf);
			Object o = valueStack.pop();
			vt.setVal(s, Operator.operate(o, vt.getVal(s), "/"));

		} else if (t.getKind() == TokenKind.Piriod) {
			VariableOrClassPush.run(sf, s);
			MethodCalling.run(sf, "method");
		} else if (t.getKind() == TokenKind.ArrayOpen) {
			Expression.run(sf);
			int index = ((Number) valueStack.pop()).intValue();
			typeStack.pop();
			sf.index++;// ]
			Object contents = vt.getVal(s);
			while (tokenArray.getKind(sf.index) == TokenKind.ArrayOpen) {
				sf.index++; // [
				contents = Array.get(contents, index);
				Expression.run(sf);
				index = ((Number) valueStack.pop()).intValue();
				typeStack.pop();
				sf.index++;// ]
			}
			sf.index++;// =
			Expression.run(sf);
			Object o = valueStack.pop();
			typeStack.pop();
			Array.set(contents, index, o);
		} else if (t.getKind() == TokenKind.PP) {
			// u++
			Object o = vt.getVal(s);
			valueStack.push(o);
			typeStack.push(vt.getType(s));
			Object ro = SmallInterpreterSupportor.getIncOrDec(o, "+");
			// type is not changed
			vt.setVal(s, ro);
		} else if (t.getKind() == TokenKind.MM) {
			// u--
			Object o = vt.getVal(s);
			valueStack.push(o);
			typeStack.push(vt.getType(s));
			Object ro = SmallInterpreterSupportor.getIncOrDec(o, "-");

			// type is not changed
			vt.setVal(s, ro);
		}
	}

}
